# -*- coding: utf-8 -*-

class basic_data:

	def __init__(self):
		"""
		check~~~ : 어떤 기본적인 값을 확인하기 위한 자료
		a_vs_b : 키값이 a이고 그결과값이 b인것을 알아내는것
		a_vs_enum : 키값이 a이고 그결과값이 enum의 값을 알아내는것
		위의 내용이 없는것은 리스트 형식을 나타내는 것
		"""
		self.vars = {}

		self.vars["알파벳"] = "abcdefghijklmnopqrstuvwxyz"
		self.vars["ㄱ"] = "ㄱㄴㄷㄹㅁㅂㅅㅇㅈㅊㅋㅌㅍㅎ"
		self.vars["ㅏ"] ="ㅏㅑㅓㅕㅗㅛㅜㅠㅡㅣ"
		self.vars["자음"] = ["ㄱ", "ㄲ", "ㄴ", "ㄷ", "ㄸ", "ㄹ", "ㅁ", "ㅂ", "ㅃ", "ㅅ", "ㅆ", "ㅇ", "ㅈ", "ㅉ", "ㅊ", "ㅋ", "ㅌ", "ㅍ", "ㅎ"]  # 19 글자
		self.vars["모음"] = ["ㅏ", "ㅐ", "ㅑ", "ㅒ", "ㅓ", "ㅔ", "ㅕ", "ㅖ", "ㅗ", "ㅘ", "ㅙ", "ㅚ", "ㅛ", "ㅜ", "ㅝ", "ㅞ", "ㅟ", "ㅠ", "ㅡ", "ㅢ", "ㅣ"]  # 21 글자
		self.vars["받침"] = ["", "ㄱ", "ㄲ", "ㄳ", "ㄴ", "ㄵ", "ㄶ", "ㄷ", "ㄹ", "ㄺ", "ㄻ", "ㄼ", "ㄽ", "ㄾ", "ㄿ", "ㅀ", "ㅁ", "ㅂ", "ㅄ", "ㅅ", "ㅆ", "ㅇ", "ㅈ", "ㅊ", "ㅋ", "ㅌ", "ㅍ", "ㅎ"]  # 28 글자, 없는것 포함
		self.vars["가"] = "가나다라마바사아자차카타파하"
		self.vars["숫자"]= "1234567890"
		self.vars["그리스문자"]= "αβγδεζήθικλμνξόπρΣτ"
		self.vars["로마숫자"] = "ⅠⅡⅢⅣⅤⅥⅦⅧⅨⅩ"
		self.vars["원ㄱ"] = "㉠㉡㉢㉣㉤㉥㉦㉧㉨㉩㉪㉫㉬㉭"
		self.vars["원가"] = "㉮㉯㉰㉱㉲㉳㉴㉵㉶㉷㉸㉹㉺㉻"
		self.vars["원a"] = "ⒶⒷⒸⒹⒺⒻⒼⒽⒾⒿⓀⓁⓂⓃⓄⓅⓆⓇⓈⓉⓊⓋⓌⓍⓎⓏ"
		self.vars["원1"] ="⓪①②③④⑤⑥⑦⑧⑨⑩⑪⑫⑬⑭⑮⑯⑰⑱⑲⑳㉑㉒㉓㉔㉕㉖㉗㉘㉙㉚㉛㉜㉝㉞㉟㊱㊲㊳㊴㊵㊶㊷㊸㊹㊺㊻㊼㊽㊾㊿"
		self.vars["month"] = ['JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER']


		self.vars["h12"] = [0, 30, 60, 90, 120, 150, 180, 210, 240, 270, 300, 330]
		self.vars["sl10"] = [[100, 0], [90, 10], [80, 20], [70, 30], [60, 40], [50, 50], [40, 60], [30, 70], [10, 80], [10, 90], [0, 100]]
		self.vars["sl11"] = [[100, 0], [100, 10], [100, 20], [100, 30], [100, 40], [100, 50], [100, 60], [100, 70], [100, 80], [100, 90], [100, 100]]
		self.vars["sl12"] = [[90, 50], [80, 30], [80, 50], [80, 70], [50, 20], [50, 40], [50, 60], [50, 80], [20, 20], [20, 40], [20, 60], [20, 80]]
		self.vars["hsl12"] = [[0, 100, 50], [30, 100, 50], [60, 100, 50], [90, 100, 50], [120, 100, 50], [150, 100, 50], [180, 100, 50], [210, 100, 50], [240, 100, 50], [270, 100, 50], [300, 100, 50], [330, 100, 50]]
		self.vars["rgb12"] = [[255, 0, 0], [255, 128, 0], [255, 255, 0], [128, 255, 0],[0, 255, 0], [0, 255, 128], [0, 255, 255], [0, 128, 255],[0, 0, 255], [128, 0, 255], [255, 0, 255], [255, 0, 128], ]
		self.vars["sl_big_step"] = [[100, 80], [100, 77], [100, 68], [100, 59],[100, 50], [90, 41], [80, 32], [70, 23], [60, 14] ]

		self.vars["sl_no_vs_sl_small_step"] = {"1": [0, 12], "2": [0, 9], "3": [0, 6], "4": [0, 3],
		                                           "5": [0, 0], "6": [0, -3], "7": [0, -6], "8": [0, -9], "9": [0, -12], "0": [0, -14], }

		self.vars["color_tone_12_names_vs_no"] = {"연한": 0, "밝은회색": 1, "회색": 2, "어두운회색": 3, "옅은": 4, "부드러운": 5, "탁한": 6, "어두운": 7, "밝은": 8, "강한": 9, "짙은": 10, "선명한": 11}


		self.vars["excel56_rgb"] = [[255, 0, 0], [0, 255, 0], [0, 0, 255], [255, 255, 0], [255, 0, 255],
					 [0, 255, 255], [153, 51, 102], [255, 255, 204], [204, 255, 255], [102, 0, 102],
					 [255, 128, 128], [0, 102, 204], [204, 204, 255], [0, 204, 255], [204, 255, 204],
					 [255, 255, 153], [153, 204, 255], [255, 153, 204], [204, 153, 255], [255, 204, 153],
					 [51, 102, 255], [51, 204, 204], [153, 204, 0], [255, 204, 0], [255, 153, 0],
					 [255, 102, 0], [102, 102, 153], [150, 150, 150], [0, 51, 102], [51, 153, 102],
					 [0, 51, 0], [51, 51, 0], [153, 51, 0], [51, 51, 153], [51, 51, 51],
					 [128, 0, 0], [0, 128, 0], [0, 0, 128], [128, 128, 0], [128, 0, 128],
					 [0, 128, 128], [192, 192, 192], [128, 128, 128], [153, 153, 255], [0, 0, 0],
					 [255, 255, 255],[102, 102, 153], [150, 150, 150], [0, 51, 102], [51, 153, 102],
			[0, 51, 0], [51, 51, 0], [153, 51, 0], [153, 51, 102], [51, 51, 153],[51, 51, 51]]

		self.vars["excel46_rgb"] = self.vars["excel56_rgb"][0:46]



		self.vars["color_mode"]= ["단색조합", "등간격 3색 조화", "보색", "인접색", "근접보색조합",
							   "고명도배색", "고명도배색+약간더 부드러운 이미지",
							   "중명도배색", "중명도배색+약간더 부드러운 이미지", "저중명도배색", "저명도배색+약간더 어두운 이미지",
							   "명도차가 큰 배색", "명도차가 큰 배색 + 근접보색",
							   "고채도 배색", "채도차가 큰 배색", "저채도 배색", ]

		self.vars["색강도_vs_sl"] = {"+++++": [0, 15], "++++": [0, 12], "+++": [0, 9], "++": [0, 6], "+": [0, 3], "-": [0, -3],"--": [0, -6], "---": [0, -9], "----": [0, -12], "-----": [0, -14], }
		self.vars["색강도"] = ["+++++", "++++", "+++", "++", "+", "", "-", "--", "---", "----", "-----"]
		self.vars["color_vs_h"] =  {"red": 0, "ora": 30, "yel": 60, "gre_yel": 90, "gre": 120, "gre_cya": 150 , "cya": 180, "blu_cya": 210, "blu": 240, "blu_mag": 270, "mag": 300, "red_mag": 330, "gra": 0, "whi": 0, "bla": 0, }
		self.vars["color_vs_index"] = {"red": 0, "ora": 1, "yel": 2, "gre_yel": 3, "gre": 4, "gre_cya": 5, "cya": 6, "blu_cya": 7, "blu": 8, "blu_mag": 9, "mag": 10, "red_mag": 11, "gra": 12, "whi": 13, "bla": 14}
		self.vars["no_vs_sl"] = {"1": [0, 12], "2": [0, 9], "3": [0, 6], "4": [0, 3], "5": [0, 0], "6": [0, -3], "7": [0, -6], "8": [0, -9], "9": [0, -12], "0": [0, -14], }
		self.vars["line_style_vs_enum"] = {"basic": 1, "": 1, "-": 1, ".": -4118, "-.": 4, "-..": 5, "..": -4115, "=": 4119, "no": -4142, "/..": 13, "/.": 13, "실선": 1, "점선": 2, "가는점선": 1, "굵은실선": 6, }


		self.vars["check_color_eng"]={
			"빨": "red", "적": "red", "빨강": "red", "red": "red", "r": "red", "빨간색": "red", "빨강색": "red",0: "red",
			"주": "ora", "주황": "ora", "주황색": "ora", "오렌지": "ora", "yr": "ora", "yellowred": "ora", "yellow_red": "ora", "yel_red": "ora", "yellow red": "ora", "o": "ora", "orange": "ora", "ora": "ora", 1: "ora", 30: "ora",
			"노": "yel", "노랑": "yel", "노랑색": "yel", "황색": "yel", "y": "yel", "yellow": "yel", "yel": "yel",60: "yel",
			"연": "gre_yel", "연두": "gre_yel", "연두색": "gre_yel", "gre_yel": "gre_yel", "gy": "gre_yel", "greenyellow": "gre_yel", "green_yellow": "gre_yel", "green yellow": "gre_yel", "green-yellow": "gre_yel", "yg": "gre_yel",3: "gre_yel", 90: "gre_yel",
			"초": "gre", "초록": "gre", "초록색": "gre", "g": "gre", "green": "gre", "gre": "gre", "녹색": "gre",4: "gre", 120: "gre",
			"연초록": "gre_cya", "gre_cya": "gre_cya", "greencyan": "gre_cya", "green_cyan": "gre_cya", "green cyan": "gre_cya", "cg": "gre_cya", "gc": "gre_cya",5: "gre_cya", 150: "gre_cya",
			"옥": "cya", "옥색": "cya", "하늘색": "cya", "하늘": "cya", "c": "cya", "cya": "cya", "cyan": "cya",6: "cya", 180: "cya",
			"청록": "blu_cya", "청록색": "blu_cya", "청": "blu_cya", "군청색": "blu_cya", "청색": "blu_cya", "blu_cya": "blu_cya", "bluecyan": "blu_cya", "blue_cyan": "blu_cya", "blue cyan": "blu_cya", "cb": "blu_cya", "bg": "blu_cya", "bluegreen": "blu_cya", "bc": "blu_cya",7: "blu_cya", 210: "blu_cya",
			"파": "blu", "파랑": "blu", "파랑색": "blu", "b": "blu", "blue": "blu", "blu": "blu",8: "blu", 240: "blu",
			"남": "blu_mag", "남색": "blu_mag", "blu_mag": "blu_mag", "bluemagenta": "blu_mag", "blue_magenta": "blu_mag", "blue magenta": "blu_mag", "bm": "blu_mag", "pb": "blu_mag", "purpleblue": "blu_mag", "purple_blue": "blu_mag", "purple blue": "blu_mag",
			"핑크": "pin", "핑크색": "pin", "분홍": "pin", "분홍색": "pin", "pink": "pin","pin": "pin",
			"자홍": "red_mag", "자주": "red_mag", "자주색": "red_mag", "redmagenta": "red_mag",  "red_mag": "red_mag", "red_magenta": "red_mag", "red magenta": "red_mag", "rm": "red_mag", "mr": "red_mag",11: "red_mag", 330: "red_mag",
			"보": "mag", "보라": "mag", "보라색": "mag", "magenta": "mag", "m": "mag", "mag": "mag", "purple": "mag", "자색": "mag", "violet": "mag", "vio": "mag",10: "mag", 300: "mag",
			"회": "gra", "회색": "gra", "gra": "gra", "gray": "gra",12: "gra",
			"흰": "whi", "하양": "whi", "하양색": "whi", "하얀색": "whi", "흰색": "whi", "white": "whi", "whi": "whi",13: "whi",
			"검": "bla", "검정": "bla", "검정색": "bla", "흑": "bla", "흑색": "bla", "black": "bla", "bla": "bla",14: "bla",
			"갈색": "bro", "brown": "bro", "bro": "bro",
			"주홍": "sca", "sca": "sca", "scarlet": "sca", "주홍색": "sca", "선홍색": "sca", "선홍": "sca",
			"연분홍": "pal_pin", "pale_pink": "pal_pin", "pal_pin": "pal_pin",
			"유황색": "sul_yel", "유황": "sul_yel","sul_yel": "sul_yel",
		}

		self.vars["color_eng"] =list(set(self.vars["check_color_eng"].values()))
		self.vars["color_eng_12"] = ['red', 'ora', 'yel', 'gre_yel', 'gre', 'gre_cya', 'cya', 'blu_cya', 'blu', 'blu_mag', 'pin', 'red_mag']

		self.vars["check_color_kor"] = {
			"빨": "빨강", "적": "빨강", "red": "빨강", "r": "빨강", "빨간색": "빨강", "빨강색": "빨강",
			"주": "오렌지", "주황": "오렌지", "주황색": "오렌지", "ora": "오렌지", "yr": "오렌지", "yellowred": "오렌지", "yellow_red": "오렌지", "yel_red": "오렌지", "yellow red": "오렌지", "o": "오렌지", "orange": "오렌지",
			"노": "노랑", "노랑": "노랑", "노랑색": "노랑", "황색": "노랑", "y": "노랑", "yellow": "노랑", "yel": "노랑",
			"연": "연두", "연두": "연두", "연두색": "연두", "gy": "연두", "greenyellow": "연두", "green_yellow": "연두", "gre_yel": "연두", "green yellow": "연두", "green-yellow": "연두", "yg": "연두",
			"초": "초록", "초록": "초록", "초록색": "초록", "g": "초록", "녹색": "초록",
			"연초록": "연초록", "greencyan": "연초록", "green_cyan": "연초록", "gre_cya": "연초록", "green cyan": "연초록", "cg": "연초록", "gc": "연초록",
			"옥": "하늘", "옥색": "하늘", "하늘색": "하늘", "하늘": "하늘", "c": "하늘", "cya": "하늘", "cyan": "하늘",
			"청록": "군청색", "청록색": "군청색", "청": "군청색", "군청색": "군청색", "청색": "군청색", "bluecyan": "군청색", "blue_cyan": "군청색", "blu_cya": "군청색", "blue cyan": "군청색", "cb": "군청색", "bg": "군청색", "bluegreen": "군청색",
			"파": "파랑", "파랑": "파랑", "파랑색": "파랑", "b": "파랑", "blue": "파랑", "blu": "파랑",
			"남": "남색", "남색": "남색", "bluemagenta": "남색", "blue_magenta": "남색", "blu_mag": "남색", "blue magenta": "남색", "bm": "남색", "pb": "남색", "purpleblue": "남색", "purple_blue": "남색", "pur_blu": "남색", "purple blue": "남색",
			"핑크": "핑크", "핑크색": "핑크", "분홍": "핑크", "분홍색": "핑크", "pink": "핑크",
			"자홍": "자주", "자주": "자주", "자주색": "자주", "redmagenta": "자주", "red_mag": "자주", "red_magenta": "자주", "red magenta": "자주", "rm": "자주", "mr": "자주",
			"보": "보라", "보라": "보라", "보라색": "보라", "magenta": "보라", "m": "보라", "mag": "보라", "purple": "보라", "자색": "보라", "violet": "보라", "vio": "보라",
			"회": "회색", "회색": "회색", "gra": "회색", "gray": "회색",
			"흰": "하양", "하양": "하양", "하양색": "하양", "하얀색": "하양", "흰색": "하양", "white": "하양", "whi": "하양",
			"검": "검정", "검정": "검정", "검정색": "검정", "흑": "검정", "흑색": "검정", "black": "검정", "bla": "검정",
			"갈색": "갈색", "brown": "갈색", "bro": "갈색",
			"주홍": "주홍", "scarlet": "주홍","sca": "주홍", "주홍색": "주홍", "선홍색": "주홍", "선홍": "주홍",
			"연분홍": "연분홍", "pale_pink": "연분홍","pal_pin": "연분홍",
			"유황색": "유황", "유황": "유황","sulphur_yellow": "유황","sul_yel": "유황",
		}

		self.vars["color_kor"] =list(set(self.vars["check_color_kor"].values()))
		self.vars["color_kor_12"] = ["빨강", "오렌지", "노랑", "연두", "초록", "연초록", "하늘", "군청색", "파랑", "남색", "핑크", "자주"]


		self.vars["check_color_tone"] = {
			"파스텔": "pastel", "pastel": "pastel",
			"p": "p", "pale": "p", "pal": "p", "연한": "p",
			"ltg": "ltg", "light_grayish": "ltg", "gra+": "ltg", "밝은회색": "ltg","lightgrayish": "ltg", "밝은회색조": "ltg",
			"g": "g", "grayish": "g", "gra": "g", "회색": "g","회색조": "g",
			"dkg": "dkg", "dark_grayish": "dkg", "gra-": "dkg", "어두운회색": "dkg","darkgrayish": "dkg","어두운회색조": "dkg",
			"lt": "lt", "light": "lt", "lig": "lt", "옅은": "lt",
			"sf": "sf", "soft": "sf", "sof": "sf", "부드러운": "sf",
			"d": "d", "dull": "d", "dul": "d", "탁한": "d","둔한": "d",
			"dk": "dk", "dark": "dk", "dar": "dk", "어두운": "dk",
			"b": "b", "bright": "b", "bri": "b", "밝은": "b",
			"s": "s", "strong": "s", "str": "s", "기본": "s", "강한": "s",
			"dp": "dp", "deep": "dp", "dee": "dp", "짙은": "dp",
			"v": "v", "선명한": "v", "vivid": "v", "viv": "v",
			"black": "black", "검정": "black",
			}
		self.vars["color_tone_vs_sl"] = {"pastel": [100, 85],"p": [25, 85], "ltg": [25, 65], "g": [25, 35], "dkg": [25, 15],"lt": [50, 80], "sf": [50, 60], "d": [50, 40], "dk": [50, 20],"s": [70, 50], "b": [75, 75], "dp": [75, 25],	"v": [90, 50],}

		self.vars["color_tone_kor"] = ["연한", "밝은회색", "회색", "어두운회색", "옅은", "부드러운", "탁한", "어두운", "밝은", "강한", "짙은", "선명한"]
		self.vars["color_tone_eng"]=list(set(self.vars["check_color_tone"].values()))


		self.vars["check_change_step"] ={
			0: "0", "0": "0", "l5": "0", "+++++": "0", "pale": "0", "p": "0", "pastel": "0", "파스텔": "0", "d5": "0",
			1: "1", "1": "1", "l4": "1", "++++": "1", "light_grayish": "1", "ltg": "1", "밝은회색": "1", "d4": "1",
			2: "2", "2": "2", "l3": "2", "+++": "2", "light": "2", "lt": "2", "흐린": "2", "옅은": "2", "d3": "2",
			3: "3", "3": "3", "l2": "3", "++": "3", "soft": "3", "sf": "3", "부드러운": "3", "d2": "3",
			4: "4", "4": "4", "l1": "4", "+": "4", "bright": "4", "b": "4", "밝은": "4", "d1": "4",
			5: "5", "5": "5", "l0": "5", "": "5", "strong": "5", "s": "5", "강한": "5", "d0": "5",
			6: "6", "6": "6", "l-1": "6", "-": "6", "deep": "6", "dp": "6", "진한": "6", "d-1": "6",
			7: "7", "7": "7", "l-2": "7", "--": "7", "dull": "7", "d": "7", "탁한": "7", "d-2": "7",
			8: "8", "8": "8", "l-3": "8", "---": "8", "dark": "8", "dk": "8", "어두운": "8", "d-3": "8",
			9: "9", "9": "9", "l-4": "9", "----": "9", "grayish": "9", "g": "9", "회색": "9", "잿빛": "9", "d-4": "9",
			10: "10", "10": "10", "l-5": "10", "-----": "10", "dark_grayish": "10", "dkg": "10", "어두운회색": "10", "d-5": "10",
			}

		self.vars["color_vs_hsl"] = {
			"gra": [0, 0, 50], 	"whi": [0, 0, 100], "bla": [0, 0, 0], 	"red": [0, 100, 50],
			"ora": [30, 100, 50], "yel": [60, 100, 50], "gre_yel": [90, 100, 50], 	"gre": [120, 100, 50],
			"gre_cya": [150, 100, 50], "cya": [180, 100, 50], "blu_cya": [210, 100, 50], "blu": [240, 100, 50],
			"blu_mag": [270, 100, 50], "mag": [300, 100, 50], "red_mag": [330, 100, 50], "pin": [326, 75, 56],
			"bro": [30, 100, 40], "sca": [181, 0, 16],	"pal_pin": [348, 95, 84],	"sul_yel": [150, 75, 0],
		}

		self.vars["color_vs_color_index"] = {
			"검정색": 1, 	"흰색": 2, "빨강색": 3, "파랑색": 5, "노랑색": 6,
			"핑크색": 7, "오렌지": 46, "보라색": 13, "청록색": 14, "옅은노랑": 19,
			"옅은하늘": 20, "매실색": 18, "밝은하늘": 8, "연두색": 4, "회색20": 15,
			"회색40": 48, "회색60": 16, "회색80": 56, "진한적색": 9, "진한녹색": 10,
			"진한청색": 11, "진한황색": 12, "진한보라": 21, "진한하늘": 33, "진한산호색": 49,
			"담자색": 17, "토황색": 45, "취람색": 35, "송화색": 36, "두록색": 40,
			"주색": 22, "청현색": 23, "회보라색": 24, "밝은벽청색": 37, "선홍색": 38, "치색": 47,
			"black": 1, "white": 2, "red": 3, "blue": 5, "yellow": 6,
			"pink": 7, "orange": 46, "purple": 13, "green": 14, "gray": 15,
			"bla": 1, "whi": 2, "blu": 5, "yel": 6,
			"pin": 7, "ora": 46, "pur": 13, "gre": 14, "gra": 15,
			"검정": 1, 	"빨강": 3, "파랑": 5, "노랑": 6,
			"핑크": 7, "보라": 13, "청록": 14, "회색": 15,
		}

		self.vars["position_no_list_vs_line_position"] = {
		                                    "l": [7], "left": [7], "왼쪽": [7],
		                                    "t": [8], "top": [8], "위쪽": [8],
		                                    "b": [9], "bottom": [9], "아래쪽": [9],
		                                    "r": [10], "right": [10], "오른쪽": [10],
		                                    "h": [11], "inside-h": [11], "inh": [11], "안쪽세로": [11], "|": [11],
		                                    "v": [12], "inside-v": [12], "inv": [12], "안쪽가로": [12], "-": [12],
		                                    "a": [7, 8, 9, 10, 11, 12], "all": [7, 8, 9, 10, 11, 12],
		                                    "전부": [7, 8, 9, 10, 11, 12],
		                                    "o": [7, 8, 9, 10], "테두리": [7, 8, 9, 10], "": [7, 8, 9, 10],
		                                    "basic": [7, 8, 9, 10],
		                                    "out": [7, 8, 9, 10],
		                                    "/": [6], "대각선오른쪽": [6],
		                                    "\\": [5], "대각선왼쪽": [5],
		                                    "in": [11, 12],
		                                    "total": [5, 6, 7, 8, 9, 10, 11, 12],
		                 }

		self.vars["line_position_vs_enum"] = {"/": 6, "\\": 5, "left": 7, "top": 8, "bottom": 9, "right": 10, "inside-h": 11, "inside-v": 12, "대각선오른쪽": 6, "대각선왼쪽": 5, "왼쪽": 7, "위쪽": 8, "아래쪽": 9, "오른쪽": 10, "안쪽세로": 11, "안쪽가로": 12, }


		self.vars["line_position_vs_position_no_list"] = {
			"basic": [7,8,9,10],
			"all": [7,8,9,10],
			"": [7,8,9,10],
			"/": 6,
			"\\": 5,
			"left": 7,
			"top": 8,
			"bottom": 9,
			"right": 10,
			"inside-h": 11,
			"inside-v": 12,
			"대각선오른쪽": 6,
			"대각선왼쪽": 5,
			"왼쪽": 7,
			"위쪽": 8,
			"아래쪽": 9,
			"오른쪽": 10,
			"안쪽세로": 11,
			"안쪽가로": 12, }


		self.vars["line_style_vs_enum"] = {
			"msoArrowheadNone": 1, "msoArrowheadTriangle": 2, "msoArrowheadOpen": 3, "msoArrowheadStealth": 4,
			"msoArrowheadDiamond": 5, "msoArrowheadOval": 6,
			"": 1, "<": 2, ">o": 3, ">>": 4, ">": 2, "<>": 5, "o": 6,
			"basic": 1, "none": 1, "triangle": 2, "open": 3, "stealth": 4, "diamond": 5, "oval": 6,
			"msoArrowheadNarrow": 1, "msoArrowheadWidthMedium": 2, "msoArrowheadWide": 3,
			"msoArrowheadShort": 1, "msoArrowheadLengthMedium": 2, "msoArrowheadLong": 3,
			"short": 1, "narrow": 1, "medium": 2, "long": 3, "wide": 3,
			"-1": 1, "0": 2, "1": 3,
			"dash": 4, "dashdot": 5, "dashdotdot": 6, "rounddot": 3, "longdash": 7, "longdashdot": 8,
			"longdashdotdot": 9,
			"squaredot": 2,
			"-": 4, "-.": 5, "-..": 6, ".": 3, "--": 7, "--.": 8, "--..": 9, "ㅁ": 2,
		}

		self.vars["dic_base_cell_data"] = {
			"sheet_name": "",
			"xyxy": [100, 100, 0, 0],
			"color": 10058239,
			"line_style": "-.",
			"thickness": 0.5,
			"transparency": 0,
			"head_style": ">",
			"head_length": "0",
			"head_width": "0",
			"tail_style": ">",
			"tail_length": "0",
			"tail_width": "0",
		}

		self.vars["jamo_vs_eng"] = {
			"ㄱ" : "a", "ㄲ" : "aa", "ㄴ" : "b", "ㄷ" : "c", "ㄸ" : "cc",
			"ㄹ" : "d", "ㅁ" : "e", "ㅂ" : "f", "ㅃ" : "ff",
			"ㅅ" : "g", "ㅆ" : "gg", "ㅇ" : "h", "ㅈ" : "i",
			"ㅉ" : "ii", "ㅊ" : "j", "ㅋ" : "k", "ㅌ" : "l", "ㅍ" : "m", "ㅎ":"n",

			"ㄳ" : "ag", "ㄵ" : "bi", "ㄶ" : "bn", "ㄺ" : "da",
			"ㄻ" : "de", "ㄼ" : "df", "ㄽ" : "dg", "ㄾ" : "dl",
			"ㄿ" : "dm", "ㅀ" : "dn", "ㅄ" : "fg",


			"ㅏ" : "o", "ㅐ" : "ox", "ㅑ" : "p", "ㅒ" : "px", "ㅓ" : "q",
			"ㅔ" : "gx", "ㅕ" : "r", "ㅖ" : "rx", "ㅗ" : "s", "ㅘ" : "so",
			"ㅙ" : "sox", "ㅚ" : "sx", "ㅛ" : "t", "ㅜ" : "u", "ㅝ" : "ug",
			"ㅞ" : "ugx", "ㅟ" : "ux", "ㅠ" : "v", "ㅡ" : "w", "ㅢ" : "wx", "ㅣ":"x",

			"" : "", "_" : "z",
			}

		self.vars["eng_vs_jamo"] = {
			'a': 'ㄱ', 'aa': 'ㄲ', 'b': 'ㄴ', 'c': 'ㄷ', 'cc': 'ㄸ', 'd': 'ㄹ',
			'e': 'ㅁ', 'f': 'ㅂ', 'ff': 'ㅃ', 'g': 'ㅅ', 'gg': 'ㅆ', 'h': 'ㅇ',
			'i': 'ㅈ', 'ii': 'ㅉ', 'j': 'ㅊ', 'k': 'ㅋ', 'l': 'ㅌ', 'm': 'ㅍ',
			'n': 'ㅎ', 'ag': 'ㄳ', 'bi': 'ㄵ', 'bn': 'ㄶ', 'da': 'ㄺ', 'de': 'ㄻ',
			'df': 'ㄼ', 'dg': 'ㄽ', 'dl': 'ㄾ', 'dm': 'ㄿ', 'dn': 'ㅀ', 'fg': 'ㅄ',
			'o': 'ㅏ', 'ox': 'ㅐ', 'p': 'ㅑ', 'px': 'ㅒ', 'q': 'ㅓ', 'gx': 'ㅔ',
			'r': 'ㅕ', 'rx': 'ㅖ', 's': 'ㅗ', 'so': 'ㅘ', 'sox': 'ㅙ', 'sx': 'ㅚ',
			't': 'ㅛ', 'u': 'ㅜ', 'ug': 'ㅝ', 'ugx': 'ㅞ', 'ux': 'ㅟ', 'v': 'ㅠ',
			'w': 'ㅡ', 'wx': 'ㅢ', 'x': 'ㅣ', '': '', 'z': '_'}

		self.vars["eng_jamo_pair"] = [
			[['sox', 'ㅙ'], ['ugx', 'ㅞ'],],
			[['ox', 'ㅐ'], ['px', 'ㅒ'], ['gx', 'ㅔ'], ['rx', 'ㅖ'], ['so', 'ㅘ'], ['sx', 'ㅚ'], ['wx', 'ㅢ'], ['ug', 'ㅝ'], ['ux', 'ㅟ'],],
			[['a', 'ㄱ'],['b', 'ㄴ'],['c', 'ㄷ'], ['d', 'ㄹ'], ['e', 'ㅁ'], ['f', 'ㅂ'], ['g', 'ㅅ'], ['h', 'ㅇ'], ['i', 'ㅈ'], ['j', 'ㅊ'], ['k', 'ㅋ'], ['l', 'ㅌ'], ['m', 'ㅍ'], ['n', 'ㅎ']],
			[['aa', 'ㄲ'], ['cc', 'ㄸ'],['ff', 'ㅃ'], ['gg', 'ㅆ'], ['ii', 'ㅉ'], ['ag', 'ㄳ'], ['bi', 'ㄵ'], ['bn', 'ㄶ'], ['da', 'ㄺ'], ['de', 'ㄻ'], ['df', 'ㄼ'], ['dg', 'ㄽ'], ['dl', 'ㄾ'], ['dm', 'ㄿ'], ['dn', 'ㅀ'], ['fg', 'ㅄ'],],
			[['o', 'ㅏ'], ['p', 'ㅑ'], ['q', 'ㅓ'], ['r', 'ㅕ'], ['s', 'ㅗ'], ['t', 'ㅛ'], ['u', 'ㅜ'], ['v', 'ㅠ'], ['w', 'ㅡ'], ['x', 'ㅣ'],],
		    [['z', '_']],
			]

		self.vars["check_color_tone"] = {
			"파스텔": "pastel", "pastel": "pastel",
			"p": "p", "pale": "p", "pal": "p", "연한": "p",
			"ltg": "ltg", "light_grayish": "ltg", "gra+": "ltg", "밝은회색": "ltg",
			"g": "g", "grayish": "g", "gra": "g", "회색": "g",
			"dkg": "dkg", "dark_grayish": "dkg", "gra-": "dkg", "어두운회색": "dkg",
			"lt": "lt", "light": "lt", "lig": "lt", "옅은": "lt",
			"sf": "sf", "soft": "sf", "sof": "sf", "부드러운": "sf",
			"d": "d", "dull": "d", "dul": "d", "탁한": "d",
			"dk": "dk", "dark": "dk", "dar": "dk", "어두운": "dk",
			"b": "b", "bright": "b", "bri": "b", "밝은": "b",
			"s": "s", "strong": "s", "str": "s", "기본": "s", "강한": "s",
			"dp": "dp", "deep": "dp", "dee": "dp", "짙은": "dp",
			"v": "v", "선명한": "v", "vivid": "v", "viv": "v",
			"black": "black", "검정": "black",
			}


		self.vars["color_style"]  = list(set(self.vars["check_color_tone"].values()))
		self.vars["color_tone"] = self.vars["pccs_style"] =["p", "ltg", "g", "dkg", "lt", "sf", "d", "dk", "b", "s", "dp", "v"]

		self.vars["color_index_vs_rgb"] = {
			1: [0, 0, 0], 2: [255, 255, 255], 3: [255, 0, 0], 4: [0, 255, 0], 5: [0, 0, 255],
			6: [255, 255, 0], 7: [255, 0, 255], 8: [0, 255, 255], 9: [128, 0, 0], 10: [0, 128, 0],
			11: [0, 0, 128], 12: [128, 128, 0], 13: [128, 0, 128], 14: [0, 128, 128], 15: [192, 192, 192],
			16: [128, 128, 128], 17: [153, 153, 255], 18: [153, 51, 102], 19: [255, 255, 204], 20: [204, 255, 255],
			21: [102, 0, 102], 22: [255, 128, 128], 23: [0, 102, 204], 24: [204, 204, 255], 25: [0, 0, 128],
			26: [255, 0, 255], 27: [255, 255, 0], 28: [0, 255, 255], 29: [128, 0, 128], 30: [128, 0, 0],
			31: [0, 128, 128], 32: [0, 0, 255], 33: [0, 204, 255], 34: [204, 255, 255], 35: [204, 255, 204],
			36: [255, 255, 153], 37: [153, 204, 255], 38: [255, 153, 204], 39: [204, 153, 255], 40: [255, 204, 153],
			41: [51, 102, 255], 42: [51, 204, 204], 43: [153, 204, 0], 44: [255, 204, 0], 45: [255, 153, 0],
			46: [255, 102, 0], 47: [102, 102, 153], 48: [150, 150, 150], 49: [0, 51, 102], 50: [51, 153, 102],
			51: [0, 51, 0], 52: [51, 51, 0], 53: [153, 51, 0], 54: [153, 51, 102], 55: [51, 51, 153],
			56: [51, 51, 51], }


		self.vars["line_thickness_vs_enum"] = {
			"-1": 1, "매우가는선": 1, "0": 2, "": 2, "basic": 2, "가는선": 2,
			"1": -4138, "일반선": 4138, "2": 4, "굵은선": 4,
			"4": 1, "5": 2, "6": -4138, "7": 4,
			"실선": -4138, "진한선": 4,"hairline": 1, "thick": 4,
			"thin": 2, "t-2": 1, "t0": -4138, "t1": 4, "t-1": 2,
			"일반": -4138,
			"-": -4115, "-.": 4, "-..": 5, ".": -4118, "=": -4119, "no": -4142, "/.": 13,
			"점선": 2, "가는점선": 1, "굵은실선": 6,
			"..": -4115, "/..": 13, }

		self.vars["color_index_vs_color"] = {
			1: "검정색", 	2: "흰색", 3: "빨강색", 5: "파랑색", 6: "노랑색",
			7: "핑크색", 46: "오렌지", 13: "보라색", 14: "청록색", 19: "옅은노랑",
			20: "옅은하늘", 18: "매실색", 8: "밝은하늘", 4: "연두색", 15: "회색20",
			48: "회색40", 16: "회색60", 56: "회색80", 9: "진한적색", 10: "진한녹색",
			11: "진한청색", 12: "진한황색", 21: "진한보라", 33: "진한하늘", 49: "진한산호색",
			17: "담자색", 45: "토황색", 35: "취람색", 36: "송화색", 40: "두록색",
			22: "주색", 23: "청현색", 24: "회보라색", 37: "밝은벽청색", 38: "선홍색", 47: "치색",
		}

		#기본 색스타일을 기본스타일로 변경하는 것이다
		self.vars["check_color_style"] = {"v": "v", "b": "b", "s": "s", "dp": "dp", "lt": "lt", "sf": "sf", "d": "d", "dk": "dk", "p": "p", "ltg": "ltg", "g": "g", "dkg": "dkg",
				"vivid": "v", "bright": "b", "strong": "s", "deep": "dp", "light": "lt", "soft": "sf", "dull": "d", "dark": "dk", "pale": "p", "lightgrayish": "ltg", "grayish": "g", "darkgrayish": "dkg",
				"viv": "v", "bri": "b", "str": "s", "dee": "dp", "lig": "lt", "sof": "sf", "dul": "d", "dar": "dk", "pal": "p", "gra+": "ltg", "gra": "g", "gra-": "dkg",
				"선명한": "v", "밝은": "b", "강한": "s", "짙은": "dp", "옅은": "lt", "부드러운": "sf", "둔한": "d", "어두운": "dk", "연한": "p", "밝은회색조": "ltg", "회색조": "g", "어두운회색조": "dkg"}

		self.vars["color_vs_color_index"] = {
			"검정": 1, 	"흰색": 2, "빨강": 3, "파랑": 5, "노랑": 6,
			"핑크": 7, "오렌지": 46, "보라": 13, "청록": 14, "회색": 15,
			"black": 1, "white": 2, "red": 3, "blue": 5, "yellow": 6,
			"pink": 7, "orange": 46, "purple": 13, "green": 14, "gray": 15,
			"bla": 1, "whi": 2, "blu": 5, "yel": 6,
			"pin": 7, "ora": 46, "pur": 13, "gre": 14, "gra": 15,
		}

		self.vars["no_vs_color_mode"] ={1: "단색조합", "단색조합": 1, "강력한 대기효과와 넓은공간감": 1,
							  2: "등간격 3색 조화", "등간격 3색 조화": 2, "활동적인 인상과 이미지": 2,
							  3: "보색", "보색": 3, "강력한비교": 3,
							  4: "인접색", "인접색": 4, "비슷한색 찾기": 4,
							  5: "근접보색조합", "근접보색조합": 5, "보색의 강한 인상이 부담스러울때 보색의 근처에있는 색": 5,
							  6: "고명도배색", "고명도배색": 6,
							  7: "고명도배색+약간더 부드러운 이미지", "고명도배색+약간더 부드러운 이미지": 7,
							  8: "중명도배색", "중명도배색": 8,
							  9: "중명도배색+약간더 부드러운 이미지", "중명도배색+약간더 부드러운 이미지": 9,
							  10: "저중명도배색", "저중명도배색": 10,
							  11: "저명도배색+약간더 어두운 이미지", "저명도배색+약간더 어두운 이미지": 11,
							  12: "명도차가 큰 배색", "명도차가 큰 배색": 12,
							  13: "명도차가 큰 배색 + 근접보색", "명도차가 큰 배색 + 근접보색": 13,
							  14: "고채도 배색", "고채도 배색": 14,
							  15: "채도차가 큰 배색", "채도차가 큰 배색": 15,
							  16: "저채도 배색", "저채도 배색": 16, "차분하고 무거운 이미지": 16,
							  }

		self.vars["hsl_by_johannes"] = [
			[[0, 100, 0], [0, 100, 10], [0, 100, 20], [0, 100, 30], [0, 100, 40], [0, 100, 50], [0, 100, 60], [0, 100, 70],
			 [0, 100, 80], [0, 100, 90], [0, 100, 100]],
			[[30, 100, 0], [30, 100, 10], [30, 100, 20], [30, 100, 30], [30, 100, 40], [30, 100, 50], [30, 100, 60],
			 [30, 100, 70], [30, 100, 80], [30, 100, 90], [30, 100, 100]],
			[[60, 100, 0], [60, 100, 10], [60, 100, 20], [60, 100, 30], [60, 100, 40], [60, 100, 50], [60, 100, 60],
			 [60, 100, 70], [60, 100, 80], [60, 100, 90], [60, 100, 100]],
			[[90, 100, 0], [90, 100, 10], [90, 100, 20], [90, 100, 30], [90, 100, 40], [90, 100, 50], [90, 100, 60],
			 [90, 100, 70], [90, 100, 80], [90, 100, 90], [90, 100, 100]],
			[[120, 100, 0], [120, 100, 10], [120, 100, 20], [120, 100, 30], [120, 100, 40], [120, 100, 50], [120, 100, 60],
			 [120, 100, 70], [120, 100, 80], [120, 100, 90], [120, 100, 100]],
			[[150, 100, 0], [150, 100, 10], [150, 100, 20], [150, 100, 30], [150, 100, 40], [150, 100, 50], [150, 100, 60],
			 [150, 100, 70], [150, 100, 80], [150, 100, 90], [150, 100, 100]],
			[[180, 100, 0], [180, 100, 10], [180, 100, 20], [180, 100, 30], [180, 100, 40], [180, 100, 50], [180, 100, 60],
			 [180, 100, 70], [180, 100, 80], [180, 100, 90], [180, 100, 100]],
			[[210, 100, 0], [210, 100, 10], [210, 100, 20], [210, 100, 30], [210, 100, 40], [210, 100, 50], [210, 100, 60],
			 [210, 100, 70], [210, 100, 80], [210, 100, 90], [210, 100, 100]],
			[[240, 100, 0], [240, 100, 10], [240, 100, 20], [240, 100, 30], [240, 100, 40], [240, 100, 50], [240, 100, 60],
			 [240, 100, 70], [240, 100, 80], [240, 100, 90], [240, 100, 100]],
			[[270, 100, 0], [270, 100, 10], [270, 100, 20], [270, 100, 30], [270, 100, 40], [270, 100, 50], [270, 100, 60],
			 [270, 100, 70], [270, 100, 80], [270, 100, 90], [270, 100, 100]],
			[[300, 100, 0], [300, 100, 10], [300, 100, 20], [300, 100, 30], [300, 100, 40], [300, 100, 50], [300, 100, 60],
			 [300, 100, 70], [300, 100, 80], [300, 100, 90], [300, 100, 100]],
			[[330, 100, 0], [330, 100, 10], [330, 100, 20], [330, 100, 30], [330, 100, 40], [330, 100, 50], [330, 100, 60],
			 [330, 100, 70], [330, 100, 80], [330, 100, 90], [330, 100, 100]]]

		self.vars["sl_by_faber"] = [[[100, 0], [100, 50], [0, 0]],
					[[0, 0], [0, 75], [0, 100]],
					[[100, 0], [25, 75], [0, 100]],
					[[25, 0], [10, 50], [0, 75]],
					[[100, 0], [0, 0], [0, 100]],
					[[25, 0], [10, 50], [0, 75], [25, 75]], ]


		self.vars["base_cell_data"] = {	"sheet_name": "",	"xyxy": [100, 100, 0, 0],	"color": 10058239,	"line_style": "-.",	"thickness": 0.5,	"transparency": 0,	"head_style": ">",	"head_length": "0",	"head_width": "0",	"tail_style": ">",	"tail_length": "0",	"tail_width": "0",}

		self.vars["check_keyboard_hex_value"] = {"LBUTTON" : 0x01 ,"RBUTTON" :  0x02 ,"CANCEL" :  0x03 ,
								"MBUTTON" :  0x04 ,"XBUTTON1" :  0x05 ,"XBUTTON2" :  0x06 ,"BACK" :  0x08 ,"TAB" :  0x09 ,"CLEAR" :  0x0C ,
								"RETURN" :  0x0D ,"SHIFT" :  0x10 ,"CONTROL" :  0x11 ,"MENU" :  0x12 ,"PAUSE" :  0x13 ,"CAPITAL" :  0x14 ,
								"HANGUEL" :  0x15 ,"KANA" :  0x15 ,"JUNJA" :  0x17 ,"FINAL" :  0x18 ,"KANJI" :  0x19 ,"HANJA" :  0x19 ,
								"ESCAPE" :  0x1B ,"CONVERT" :  0x1C ,"NONCONVERT" :  0x1D ,"ACCEPT" :  0x1E ,"MODECHANGE" :  0x1F ,"SPACE" :  0x20 ,
								"PRIOR" :  0x21,"NEXT" :  0x22 ,"END" :  0x23 ,"HOME" :  0x24 ,"LEFT" :  0x25 ,"UP" :  0x26 ,
								"RIGHT" :  0x27 ,"DOWN" :  0x28 ,"SELECT" :  0x29 ,"PRINT" :  0x2A ,"EXECUTE" :  0x2B ,"SNAPSHOT" :  0x2C ,
								"INSERT" :  0x2D ,"DELETE" :  0x2E ,"HELP" :  0x2F ,"LWIN" :  0x5B ,"RWIN" :  0x5C ,"APPS" :  0x5D ,
								"SLEEP" :  0x5F ,"NUMPAD0" :  0x60 ,"NUMPAD1" :  0x61 ,"NUMPAD2" :  0x62 ,"NUMPAD3" :  0x63 ,"NUMPAD4" :  0x64 ,
								"NUMPAD5" :  0x65 ,"NUMPAD6" :  0x66 ,"NUMPAD7" :  0x67 ,"NUMPAD8" :  0x68 ,"NUMPAD9" :  0x69 ,"MULTIPLY" :  0x6A ,
								"ADD" :  0x6B,"SEPARATOR" :  0x6C ,"SUBTRACT" :  0x6D ,"DECIMAL" :  0x6E ,"DEVIDE" :  0x6F ,"F1" :  0x70,
								"F2" :  0x71 ,"F3" :  0x72 ,"F4" :  0x73 ,"F5" :  0x74 ,"F6" :  0x75 ,"F7" :  0x76 ,
								"F8" :  0x77 ,"F9" :  0x78 ,"F10" :  0x79 ,"F11" :  0x7A ,"F12" :  0x7B ,"F13" :  0x7C ,
								"F14" :  0x7D ,"F15" :  0x7E ,"F16" :  0x7F ,"F17" :  0x80 ,"F18" :  0x81 ,"F19" :  0x82 ,
								"F20" :  0x83 ,"F21" :  0x84 ,"F22" :  0x85 ,"F23" :  0x86 ,"F24" :  0x87 ,"NUMLOCK" :  0x90 ,
								"SCROLL" :  0x91,"LSHIFT" :  0xA0 ,"RSHIFT" :  0xA1 ,"LCONTROL" :  0xA2 ,"RCONTROL" :  0xA3 ,"LMENU" :  0xA4 ,"RMENU" :  0xA5 }


		self.vars["holiday_list"] =[
				[[20060101, 20061231], [9, 6, "양", 1, "", "임시공휴일"]],
				[[19880101, 19881231], [9, 17, "양", 1, "", "임시공휴일"]],
				[[20150101, 20151231], [8, 14, "양", 1, "", "임시공휴일"]],
				[[20160101, 20161231], [5, 6, "양", 1, "", "임시공휴일"]],
				[[20170101, 20171231], [10, 2, "양", 1, "", "임시공휴일"]],
				[[20200101, 20201231], [8, 17, "양", 1, "", "임시공휴일"]],
				[[19490101, 19901231], [1, 1, "양", 3, "", "양력설"]],
				[[19910101, 19991231], [1, 1, "양", 2, "", "양력설"]],
				[[20130101, 99991231], [1, 1, "양", 1, "", "새해 첫날"]],
				[[19490101, 19591231], [4, 5, "양", 1, "", "식목일"]],
				[[19600101, 19601231], [3, 15, "양", 1, "", "사방의날"]],
				[[19610101, 20061231], [4, 15, "양", 1, "", "식목일"]],
				[[19490101, 20081231], [7, 17, "양", 1, "", "제헌절"]],
				[[19500101, 19751231], [10, 24, "양", 1, "", "유엔의날"]],
				[[19760101, 19911231], [10, 1, "양", 1, "", "국군의날"]],
				[[19850101, 19881231], [1, 1, "음", 1, "평달", "설날"]],
				[[19890101, 99991231], [12, "말일", "음", 1, "윤달", "설날"]],
				[[19890101, 99991231], [1, 1, "음", 2, "평달", "설날"]],
				[[19490101, 99991231], [3, 1, "양", 1, "", "3.1절"]],
				[[19750101, 99991231], [4, 8, "음", 1, "평달", "부처님 오신 날"]],
				[[19750101, 99991231], [5, 5, "양", 1, "", "", "어린이날"]],
				[[19560101, 99991231], [6, 6, "양", 1, "", "", "현충일"]],
				[[19490101, 99991231], [8, 15, "양", 1, "", "", "광복절"]],
				[[19860101, 19881231], [8, 15, "음", 2, "평달", "추석"]],
				[[19890101, 99991231], [8, 14, "음", 3, "평달", "추석"]],
				[[19490101, 99991231], [10, 3, "양", 1, "", "개천절"]],
				[[19460101, 19891231], [10, 9, "양", 1, "", "한글날"]],
				[[20130101, 99991231], [10, 9, "양", 1, "", "한글날"]],
				[[19940101, 99991231], [12, 25, "양", 1, "", "기독탄신일"]],
				[[19480101, 19481231], [7, 20, "양", 1, "", "대통령선거"]],
				[[19520101, 19521231], [8, 5, "양", 1, "", "대통령선거"]],
				[[19560101, 19561231], [5, 15, "양", 1, "", "대통령선거"]],
				[[19600101, 19601231], [3, 15, "양", 1, "", "대통령선거"]],
				[[19600101, 19601231], [8, 12, "양", 1, "", "대통령선거"]],
				[[19630101, 19631231], [10, 15, "양", 1, "", "대통령선거"]],
				[[19670101, 19671231], [5, 3, "양", 1, "", "대통령선거"]],
				[[19710101, 19711231], [4, 27, "양", 1, "", "대통령선거"]],
				[[19720101, 19721231], [12, 23, "양", 1, "", "대통령선거"]],
				[[19780101, 19781231], [7, 6, "양", 1, "", "대통령선거"]],
				[[19790101, 19791231], [12, 6, "양", 1, "", "대통령선거"]],
				[[19800101, 19801231], [8, 27, "양", 1, "", "대통령선거"]],
				[[19810101, 19811231], [2, 25, "양", 1, "", "대통령선거"]],
				[[19870101, 19871231], [12, 16, "양", 1, "", "대통령선거"]],
				[[19920101, 19921231], [12, 18, "양", 1, "", "대통령선거"]],
				[[19970101, 19971231], [12, 18, "양", 1, "", "대통령선거"]],
				[[20020101, 20021231], [12, 19, "양", 1, "", "대통령선거"]],
				[[20070101, 20071231], [12, 19, "양", 1, "", "대통령선거"]],
				[[20120101, 20121231], [12, 19, "양", 1, "", "대통령선거"]],
				[[20170101, 20171231], [5, 9, "양", 1, "", "대통령선거"]],
				[[20220101, 20221231], [3, 9, "양", 1, "", "대통령선거"]],
				[[20270101, 20271231], [3, 3, "양", 1, "", "대통령선거"]],
				[[19480101, 19481231], [5, 10, "양", 1, "", "국회의원선거"]],
				[[19500101, 19501231], [5, 30, "양", 1, "", "국회의원선거"]],
				[[19540101, 19561231], [5, 20, "양", 1, "", "국회의원선거"]],
				[[19580101, 19601231], [5, 2, "양", 1, "", "국회의원선거"]],
				[[19600101, 19601231], [7, 29, "양", 1, "", "국회의원선거"]],
				[[19630101, 19631231], [11, 26, "양", 1, "", "국회의원선거"]],
				[[19670101, 19671231], [6, 8, "양", 1, "", "국회의원선거"]],
				[[19730101, 19731231], [2, 27, "양", 1, "", "국회의원선거"]],
				[[19780101, 19781231], [12, 12, "양", 1, "", "국회의원선거"]],
				[[19810101, 19811231], [3, 25, "양", 1, "", "국회의원선거"]],
				[[19850101, 18851231], [2, 12, "양", 1, "", "국회의원선거"]],
				[[19880101, 19881231], [4, 26, "양", 1, "", "국회의원선거"]],
				[[19920101, 19921231], [3, 24, "양", 1, "", "국회의원선거"]],
				[[19960101, 19961231], [4, 11, "양", 1, "", "국회의원선거"]],
				[[20000101, 20001231], [4, 13, "양", 1, "", "국회의원선거"]],
				[[20040101, 20041231], [4, 15, "양", 1, "", "국회의원선거"]],
				[[20080101, 20081231], [4, 9, "양", 1, "", "국회의원선거"]],
				[[20120101, 20121231], [4, 11, "양", 1, "", "국회의원선거"]],
				[[20160101, 20161231], [4, 13, "양", 1, "", "국회의원선거"]],
				[[20200101, 20201231], [4, 15, "양", 1, "", "국회의원선거"]],
				[[20240101, 20241231], [4, 10, "양", 1, "", "국회의원선거"]],
				[[19950101, 19951231], [6, 27, "양", 1, "", "전국동시지방선거"]],
				[[19980101, 19981231], [6, 4, "양", 1, "", "전국동시지방선거"]],
				[[20020101, 20021231], [6, 13, "양", 1, "", "전국동시지방선거"]],
				[[20060101, 20061231], [5, 31, "양", 1, "", "전국동시지방선거"]],
				[[20100101, 20101231], [6, 2, "양", 1, "", "전국동시지방선거"]],
				[[20140101, 20141231], [6, 4, "양", 1, "", "전국동시지방선거"]],
				[[20160101, 20161231], [4, 13, "양", 1, "", "전국동시지방선거"]],
				[[20180101, 20181231], [6, 13, "양", 1, "", "전국동시지방선거"]],
				[[20220101, 20221231], [6, 1, "양", 1, "", "전국동시지방선거"]],
				[[20260101, 20261231], [6, 3, "양", 1, "", "전국동시지방선거"]],
				[[20300101, 20301231], [6, 12, "양", 1, "", "전국동시지방선거"]],]



		self.vars["jfinder_gui_dic_1"] = {"탐색방법 => 최소탐색": [1, '(최소찾기)'], "탐색방법 => 최대탐색": [1, "(최대찾기)"],
		              "컴파일 방법 => 대소문자무시": [1, "(대소문자무시)"],
		              "컴파일 방법 => 개행문자포함": [1, "(개행문자포함)"],
		              "컴파일 방법 => 여러줄로표현": [1, "(여러줄로표현)"],
		              }


		self.vars["keyboard_action_list_all"] =['\\t', '\\n', '\\r', ' ', '!', '"', '#', '$', '%', '&', "'", '(',
				')', '*', '+', ',', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7',
				'8', '9', ':', ';', '<', '=', '>', '?', '@', '[', '\\', ']', '^', '_', '`',
				'a', 'b', 'c', 'd', 'e','f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
				'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
				'accept', 'add', 'alt', 'altleft', 'altright', 'apps', 'backspace',
				'browserback', 'browserfavorites', 'browserforward', 'browserhome',
				'browserrefresh', 'browsersearch', 'browserstop', 'capslock', 'clear',
				'convert', 'ctrl', 'ctrlleft', 'ctrlright', 'decimal', 'del', 'delete',
				'divide', 'down', 'end', 'enter', 'esc', 'escape', 'execute', 'f1', 'f10',
				'f11', 'f12', 'f13', 'f14', 'f15', 'f16', 'f17', 'f18', 'f19', 'f2', 'f20',
				'f21', 'f22', 'f23', 'f24', 'f3', 'f4', 'f5', 'f6', 'f7', 'f8', 'f9',
				'final', 'fn', 'hanguel', 'hangul', 'hanja', 'help', 'home', 'insert', 'junja',
				'kana', 'kanji', 'launchapp1', 'launchapp2', 'launchmail',
				'launchmediaselect', 'left', 'modechange', 'multiply', 'nexttrack',
				'nonconvert', 'num0', 'num1', 'num2', 'num3', 'num4', 'num5', 'num6',
				'num7', 'num8', 'num9', 'numlock', 'pagedown', 'pageup', 'pause', 'pgdn',
				'pgup', 'playpause', 'prevtrack', 'print', 'printscreen', 'prntscrn',
				'prtsc', 'prtscr', 'return', 'right', 'scrolllock', 'select', 'separator',
				'shift', 'shiftleft', 'shiftright', 'sleep', 'space', 'stop', 'subtract', 'tab',
				'up', 'volumedown', 'volumemute', 'volumeup', 'win', 'winleft', 'winright', 'yen',
				'command', 'option', 'optionleft', 'optionright']

		self.vars["action_key_list"] = [
		'f1', 'f10', 'f11', 'f12', 'f2', 'f3', 'f4', 'f5', 'f6', 'f7', 'f8', 'f9',	'fn',
		'left', 'right','up', 'down','end', 'home','space', 'tab',
		'alt', 'altleft', 'altright', 'ctrl', 'ctrlleft', 'ctrlright','shift', 'shiftleft', 'shiftright', 'win', 'winleft', 'winright',
		'capslock', 'del', 'delete','backspace', 'enter', 'esc', 'escape', 'insert','numlock',
		'pagedown', 'pageup', 'pgdn', 'pgup',
		'hanguel', 'hangul', 'hanja',
		'printscreen', 'prtscr',
		]


		self.vars["jfinder_gui_dic_2"] = {
			"문장 맨처음부터 맞아야함": [2, '[처음]', "type_20"],
			"맨끝에 맞아야함": [2, '[맨끝]', "type_20"],
			"한글": [2, '한글&', "type_21"],
			"한글모음": [2, '한글모음&', "type_21"],
			"한글자음": [2, '한글자음&', "type_21"],
			"영어": [2, "영어&", "type_21"],
			"한자": [2, "한자&", "type_21"],
			"일어": [2, "일본어&", "type_21"],
			"공백(공백, 탭 등)": [2, "공백&", "type_21"],
			"숫자": [2, "숫자&", "type_21"],
			"제외, not(포함하지 않음)": [2, "^", "type_22"],
			"문자1개": [2, "[문자]", "type_23"],
			"연속된 2~5까지의 숫자": [2, "[2-5", "type_24"],
			"연속된 c~e까지의 문자": [2, "[c-e", "type_24"],
			"j 또는 f 또는 i가 들어간 문자": [2, "[jfi", "type_24"],
			"abc가 단어가 들어간 문자": [2, "[(abc)", "type_24"],
			"특정단어": [2, "[(특정단어)", "type_24"],
			"메타문자": [2, "[\메타문자", "type_24"],
			"특수문자": [2, '[특수문자', "type_24"],
			"특정단어제외": [2, '[^(제외할단어)', "type_24"],
			"또는": [2, '|', "type_25"],
			}

		self.vars["jfinder_gui_dic_3"] = {"1개": [3, ":1~1]", "type_x0"],
		              "1개이상": [3, ":1~]", "type_x0"],
		              "1~10개사이": [3, ":1~10]", "type_x0"],
		              "0개이상": [3, ":0~]", "type_x0"],
		              "0개또는1개": [3, ":0~1]", "type_x0"],
		              "n개~m개": [3, ":n~m]", "type_x0"],
		              }

		self.vars["jfinder_gui_dic_4"] = {"abc중 c만 1번이상 반복되는것 찾기": [4, "abc[1~]", "type_z0"],
		              "abc중 bc만 1번이상 반복되는것 찾기": [4, "a(bc)[1~]", "type_z0"],
		              "a와 b와 c를 제외한 모든 문자와 매치": [4, "[^abc]", "type_z0"],
		              "한글로 3~5개의 글자로 된것을 그룹명 짖기": [4, "(?P<그룹명>[한글:3~5])", "type_z0"],
		              "a와 b사이의 모든문자 찾기": [4, "a[문자:1~]b", "type_z0"],
		              "a또는b또는c": [4, "a[또는]b[또는]c", "type_z0"],
		              "전방탐색 : .+(?=:) => :앞의 모든 문자": [4, ".+(?=:)", "type_z0"],
		              "후방탐색 : (?<=\$)[0-9.]+ => $뒤의 숫자": [4, "(?<=\$)[0-9.]+", "type_z0"],
		              "Html태그중 <H숫자>찾을문자<\H숫자>안의 글자": [4, "<H(0-30])>.*?</H\\1>", "type_z0"],
		              "문장중 핸드폰번호 찾기": [4, "0[1~1][숫자:2~2]-[0~1][숫자:3~4]-[0~1][숫자:4~4]", "type_z0"],
		              "2022-01-01형식의 날짜찾기": [4, "[0-9]{4})-([0-9]{2})-([0-9]{2}", "type_z0"],
		              "이메일찾기": [4, "[\w\.-]+@[\w\.-]+", "type_z0"],
		              "괄호안의 숫자 찾기": [4, "([모든문자:0~])", "type_z0"],
		              "지역 전화번호 찾기": [4, "0(2|31|32|33|41|42|43|44|51|52|53|54|55|61|62|63|64)\-{0,1}\d{3,4}\-{0,1}\d{4}",
		                             "type_z0"],
		              "주민등록번호": [4, "[0-9]{2}0[1-9]|1[0-2]0[1-9]|[1,2][0-9]|3[0,1]-[1-4][0-9]{6}", "type_z0"],
		              "금액": [4, "[숫자,][1~][원:0~1]", "type_z0"],
		              "중복된 단어 찾기": [4, "\\b(\\w+)\\s+\\1\\b", "type_z0"],
		              }

		self.vars["well_used_re"] = {
			"1개이상의 공백없애기": "[공백:2~10]",
			"괄호안의 글자만 추출": "([문자:1~20])",
			"숫자만 추출": "[공백:1~3][영어:1~10]-[숫자:1~10][영어:0~10][공백:1~5]",
			"영어와 숫자만 추출": "실시간시세",
			"~~용으로 끝나는 단어": "실시간시세",
			"핸드폰번호": "[시작][숫자:4~4]-[숫자:1~2]-[숫자:1~2][끝]", #"^\d{4}-\d{1,2}-\d{1,2}$"]
			"한글만": "[한글:1~20]",
			"복잡한 생년월일": "([0-9]{2}(?:0[1-9]|1[0-2])(?:0[1-9]|[1,2][0-9]|3[0,1]))-[1-4][0-9]{6}",
			"이메일": "^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$",

		}


		self.vars["dic_jfinder_gui_dic_2"] = {
			"문장 맨처음부터 맞아야함": [2, '[처음]', "type_20"],
			"맨끝에 맞아야함": [2, '[맨끝]', "type_20"],
			"한글": [2, '한글&', "type_21"],
			"한글모음": [2, '한글모음&', "type_21"],
			"한글자음": [2, '한글자음&', "type_21"],
			"영어": [2, "영어&", "type_21"],
			"한자": [2, "한자&", "type_21"],
			"일어": [2, "일본어&", "type_21"],
			"공백(공백, 탭 등)": [2, "공백&", "type_21"],
			"숫자": [2, "숫자&", "type_21"],
			"제외, not(포함하지 않음)": [2, "^", "type_22"],
			"문자1개": [2, "[문자]", "type_23"],
			"연속된 2~5까지의 숫자": [2, "[2-5", "type_24"],
			"연속된 c~e까지의 문자": [2, "[c-e", "type_24"],
			"j 또는 f 또는 i가 들어간 문자": [2, "[jfi", "type_24"],
			"abc가 단어가 들어간 문자": [2, "[(abc)", "type_24"],
			"특정단어": [2, "[(특정단어)", "type_24"],
			"메타문자": [2, "[\메타문자", "type_24"],
			"특수문자": [2, '[특수문자', "type_24"],
			"특정단어제외": [2, '[^(제외할단어)', "type_24"],
			"또는": [2, '|', "type_25"],
			}

		self.vars["dic_jfinder_gui_dic_3"] = {"1개": [3, ":1~1]", "type_x0"],
		              "1개이상": [3, ":1~]", "type_x0"],
		              "1~10개사이": [3, ":1~10]", "type_x0"],
		              "0개이상": [3, ":0~]", "type_x0"],
		              "0개또는1개": [3, ":0~1]", "type_x0"],
		              "n개~m개": [3, ":n~m]", "type_x0"],
		              }

		self.vars["dic_jfinder_gui_dic_4"] = {"abc중 c만 1번이상 반복되는것 찾기": [4, "abc[1~]", "type_z0"],
		              "abc중 bc만 1번이상 반복되는것 찾기": [4, "a(bc)[1~]", "type_z0"],
		              "a와 b와 c를 제외한 모든 문자와 매치": [4, "[^abc]", "type_z0"],
		              "한글로 3~5개의 글자로 된것을 그룹명 짖기": [4, "(?P<그룹명>[한글:3~5])", "type_z0"],
		              "a와 b사이의 모든문자 찾기": [4, "a[문자:1~]b", "type_z0"],
		              "a또는b또는c": [4, "a[또는]b[또는]c", "type_z0"],
		              "전방탐색 : .+(?=:) => :앞의 모든 문자": [4, ".+(?=:)", "type_z0"],
		              "후방탐색 : (?<=\$)[0-9.]+ => $뒤의 숫자": [4, "(?<=\$)[0-9.]+", "type_z0"],
		              "Html태그중 <H숫자>찾을문자<\H숫자>안의 글자": [4, "<H(0-30])>.*?</H\\1>", "type_z0"],
		              "문장중 핸드폰번호 찾기": [4, "0[1~1][숫자:2~2]-[0~1][숫자:3~4]-[0~1][숫자:4~4]", "type_z0"],
		              "2022-01-01형식의 날짜찾기": [4, "[0-9]{4})-([0-9]{2})-([0-9]{2}", "type_z0"],
		              "이메일찾기": [4, "[\w\.-]+@[\w\.-]+", "type_z0"],
		              "괄호안의 숫자 찾기": [4, "([모든문자:0~])", "type_z0"],
		              "지역 전화번호 찾기": [4, "0(2|31|32|33|41|42|43|44|51|52|53|54|55|61|62|63|64)\-{0,1}\d{3,4}\-{0,1}\d{4}",
		                             "type_z0"],
		              "주민등록번호": [4, "[0-9]{2}0[1-9]|1[0-2]0[1-9]|[1,2][0-9]|3[0,1]-[1-4][0-9]{6}", "type_z0"],
		              "금액": [4, "[숫자,][1~][원:0~1]", "type_z0"],
		              "중복된 단어 찾기": [4, "\\b(\\w+)\\s+\\1\\b", "type_z0"],
		              }


		self.vars["dic_shape_enum"] ={
			'mixed': -2,			'rectangle': 1,			'직사각형': 1,
			'parallelogram': 2,			'평행사변형': 2,			'trapezoid': 3,
			'사다리꼴': 3,			'diamond': 4,			'다이아몬드': 4,
			'roundedrectangle': 5,			'둥근모서리사각형': 5,			'Octagon': 6,
			'팔각형': 6,			'isoscelestriangle': 7,			'이등변삼각형': 7,
			'RightTriangle': 8,			'직각삼각형': 8,			'Oval': 9,
			'타원': 9,			'Hexagon': 10,			'육각형': 10,
			'Cross': 11,			'십자형': 11,			'RegularPentagon': 12,
			'오각형': 12,			'Can': 13,			'원통형': 13,
			'Cube': 14,			'정육면체': 14,			'Bevel': 15,
			'빗면사각형': 15,			'FoldedCorner': 16,			'모서리접힌사각형': 16,			'SmileyFace': 17,
			'웃는얼굴': 17,			'Donut': 18,			'원형': 18,
			'NoSymbol': 19,			'BlockArc': 20,			'막힌원호': 20,			'Heart': 21,			'하트': 21,
			'LightningBolt': 22,			'번개': 22,
			'Sun': 23,			'해': 23,			'Moon': 24,			'달': 24,			'Arc': 25,			'원호': 25,			'DoubleBracket': 26,
			'양쪽대괄호': 26,			'DoubleBrace': 27,			'양쪽중괄호': 27,			'Plaque': 28,
			'배지': 28,		'LeftBracket': 29,			'왼쪽대괄호': 29,			'RightBracket': 30,
			'오른쪽대괄호': 30,			'LeftBrace': 31,			'왼쪽중괄호': 31,			'RightBrace': 32,
			'오른쪽중괄호': 32,			'RightArrow': 33,			'오른쪽화살표': 33,			'LeftArrow': 34,
			'왼쪽화살표': 34,			'UpArrow': 35,			'위쪽화살표': 35,			'DownArrow': 36,
			'아래쪽화살표': 36,			'LeftRightArrow': 37,			'왼쪽오른쪽화살표': 37,			'UpDownArrow': 38,
			'위쪽아래쪽화살표': 38,			'QuadArrow': 39,			'상하좌우화살표': 39,			'LeftRightUpArrow': 40,
			'상좌우화살표': 40,			'BentArrow': 41,			'굽음화살표': 41,			'UTurnArrow': 42,
			'U턴화살표': 42,			'LeftUpArrow': 43,			'좌상화살표': 43,			'BentUpArrow': 44,
			'위로굽음화살표': 44,			'CurvedRightArrow': 45,			'CurvedLeftArrow': 46,			'CurvedUpArrow': 47,
			'CurvedDownArrow': 48,			'StripedRightArrow': 49,			'NotchedRightArrow': 50,			'Pentagon': 51,
			'Chevron': 52,			'RightArrowCallout': 53,			'LeftArrowCallout': 54,			'UpArrowCallout': 55,
			'DownArrowCallout': 56,			'LeftRightArrowCallout': 57,			'UpDownArrowCallout': 58,			'QuadArrowCallout': 59,
			'CircularArrow': 60,			'FlowchartProcess': 61,			'FlowchartAlternateProcess': 62,			'FlowchartDecision': 63,
			'FlowchartData': 64,			'FlowchartPredefinedProcess': 65,			'FlowchartInternalStorage': 66,			'FlowchartDocument': 67,
			'FlowchartMultidocument': 68,			'FlowchartTerminator': 69,			'FlowchartPreparation': 70,			'FlowchartManualInput': 71,
			'FlowchartManualOperation': 72,			'FlowchartConnector': 73,			'FlowchartOffpageConnector': 74,			'FlowchartCard': 75,
			'FlowchartPunchedTape': 76,			'FlowchartSummingJunction': 77,			'FlowchartOr': 78,			'FlowchartCollate': 79,
			'FlowchartSort': 80,			'FlowchartExtract': 81,			'FlowchartMerge': 82,			'FlowchartStoredData': 83,
			'FlowchartDelay': 84,			'FlowchartSequentialAccessStorage': 85,			'FlowchartMagneticDisk': 86,			'FlowchartDirectAccessStorage': 87,
			'FlowchartDisplay': 88,			'Explosion1': 89,			'Explosion2': 90,			'4pointStar': 91,
			'5pointStar': 92,			'8pointStar': 93,			'16pointStar': 94,			'24pointStar': 95,
			'32pointStar': 96,			'UpRibbon': 97,			'DownRibbon': 98,			'CurvedUpRibbon': 99,
			'CurvedDownRibbon': 100,			'VerticalScroll': 101,			'HorizontalScroll': 102,			'Wave': 103,
			'DoubleWave': 104,			'RectangularCallout': 105,			'RoundedRectangularCallout': 106,			'OvalCallout': 107,
			'CloudCallout': 108,			'LineCallout1': 109,			'LineCallout2': 110,			'LineCallout3': 111,
			'LineCallout4': 112,			'LineCallout1AccentBar': 113,			'LineCallout2AccentBar': 114,			'LineCallout3AccentBar': 115,
			'LineCallout4AccentBar': 116,			'LineCallout1NoBorder': 117,			'LineCallout2NoBorder': 118,			'LineCallout3NoBorder': 119,
			'LineCallout4NoBorder': 120,			'LineCallout1BorderandAccentBar': 121,			'LineCallout2BorderandAccentBar': 122,			'LineCallout3BorderandAccentBar': 123,
			'LineCallout4BorderandAccentBar': 124,			'ActionButtonCustom': 125,			'ActionButtonHome': 126,			'ActionButtonHelp': 127,
			'ActionButtonInformation': 128,			'ActionButtonBackorPrevious': 129,			'ActionButtonForwardorNext': 130,			'ActionButtonBeginning': 131,
			'ActionButtonEnd': 132,			'ActionButtonReturn': 133,			'ActionButtonDocument': 134,			'ActionButtonSound': 135,
			'ActionButtonMovie': 136,			'Balloon': 137,			'NotPrimitive': 138,			'FlowchartOfflineStorage': 139,
			'LeftRightRibbon': 140,			'DiagonalStripe': 141,			'Pie': 142,			'NonIsoscelesTrapezoid': 143,
			'Decagon': 144,			'Heptagon': 145,			'Dodecagon': 146,			'6pointStar': 147,
			'7pointStar': 148,			'10pointStar': 149,			'12pointStar': 150,			'Round1Rectangle': 151,
			'Round2SameRectangle': 152,			'SnipRoundRectangle': 154,			'Snip1Rectangle': 155,			'Snip2SameRectangle': 156,
			'Round2DiagRectangle': 157,			'Snip2DiagRectangle': 157,			'Frame': 158,			'HalfFrame': 159,
			'Tear': 160,			'Chord': 161,			'Corner': 162,			'MathPlus': 163,
			'MathMinus': 164,			'MathMultiply': 165,			'MathDivide': 166,			'MathEqual': 167,
			'MathNotEqual': 168,			'CornerTabs': 169,			'SquareTabs': 170,			'PlaqueTabs': 171,
			'Gear6': 172,			'Gear9': 173,			'Funnel': 174,			'PieWedge': 175,
			'LeftCircularArrow': 176,			'LeftRightCircularArrow': 177,			'SwooshArrow': 178,
			'Cloud': 179,			'ChartX': 180,			'ChartStar': 181,			'ChartPlus': 182,			'LineInverse': 183,}
